BuildRequires:	e2fsprogs-devel
Source10: kmodtool_nilfs2
%define kmodtool bash %{SOURCE10}
# % define kmodtool bash /usr/lib/rpm/redhat/kmodtool
%{!?kversion: %define kversion 2.6.18-128.el5}

%define kmod_name nilfs
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define PAEvar PAE
%endif
%ifarch i686 x86_64 ia64
%define xenvar xen
%endif
%ifarch ppc64
%define kdumpvar kdump
%endif 

%{!?kvariants: %define kvariants %{?upvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}

# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 

Name:           %{kmod_name}-kmod
Version:        2.0.13
Release:        2.%(echo %{kverrel} | tr - _)
Summary:        %{kmod_name} kernel module

License:        GPL
Group:          System Environment/Kernel
URL:            http://www.nilfs.org/

Source0:        nilfs-%{version}.tar.bz2
Patch1:		nilfs-rhel5-kern-feature.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i686 ia64 ppc64 s390x x86_64

%description
nilfs - A new implementation of a log-structured file system.

# magic hidden here:
#% define kmp_version %{version}
#% define kmp_release %{release}
#% {expand:% (% {kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
# {kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
# sleep 5
%setup -q -c -T -a 0
pushd %{kmod_name}-%{version}
%patch1 -p1

popd
for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-%{version} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant/fs
    make -C "${ksrc}" modules M=$PWD
    popd
done


%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant/fs
    make -C "${ksrc}" modules_install M=$PWD
    popd
done
# Temporarily executable for stripping, fixed later in %%files.
# chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
